<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PostalOrderEventsForMaiOutput StructType
 * Meta informations extracted from the WSDL
 * - type: tns:PostalOrderEventsForMaiOutput
 * @subpackage Structs
 */
class PostalOrderEventsForMaiOutput extends AbstractStructBase
{
    /**
     * The PostalOrderEvent
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PostalOrderEvent[]
     */
    public $PostalOrderEvent;
    /**
     * Constructor method for PostalOrderEventsForMaiOutput
     * @uses PostalOrderEventsForMaiOutput::setPostalOrderEvent()
     * @param \StructType\PostalOrderEvent[] $postalOrderEvent
     */
    public function __construct(array $postalOrderEvent = array())
    {
        $this
            ->setPostalOrderEvent($postalOrderEvent);
    }
    /**
     * Get PostalOrderEvent value
     * @return \StructType\PostalOrderEvent[]|null
     */
    public function getPostalOrderEvent()
    {
        return $this->PostalOrderEvent;
    }
    /**
     * Set PostalOrderEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\PostalOrderEvent[] $postalOrderEvent
     * @return \StructType\PostalOrderEventsForMaiOutput
     */
    public function setPostalOrderEvent(array $postalOrderEvent = array())
    {
        foreach ($postalOrderEvent as $postalOrderEventsForMaiOutputPostalOrderEventItem) {
            // validation for constraint: itemType
            if (!$postalOrderEventsForMaiOutputPostalOrderEventItem instanceof \StructType\PostalOrderEvent) {
                throw new \InvalidArgumentException(sprintf('The PostalOrderEvent property can only contain items of \StructType\PostalOrderEvent, "%s" given', is_object($postalOrderEventsForMaiOutputPostalOrderEventItem) ? get_class($postalOrderEventsForMaiOutputPostalOrderEventItem) : gettype($postalOrderEventsForMaiOutputPostalOrderEventItem)), __LINE__);
            }
        }
        $this->PostalOrderEvent = $postalOrderEvent;
        return $this;
    }
    /**
     * Add item to PostalOrderEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\PostalOrderEvent $item
     * @return \StructType\PostalOrderEventsForMaiOutput
     */
    public function addToPostalOrderEvent(\StructType\PostalOrderEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PostalOrderEvent) {
            throw new \InvalidArgumentException(sprintf('The PostalOrderEvent property can only contain items of \StructType\PostalOrderEvent, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PostalOrderEvent[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PostalOrderEventsForMaiOutput
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
