<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SmsHistoryRecord StructType
 * @subpackage Structs
 */
class SmsHistoryRecord extends AbstractStructBase
{
    /**
     * The Id
     * @var int
     */
    public $Id;
    /**
     * The Number
     * @var string
     */
    public $Number;
    /**
     * The NotificationTypeID
     * @var int
     */
    public $NotificationTypeID;
    /**
     * The NotificationTypeName
     * @var string
     */
    public $NotificationTypeName;
    /**
     * The NotificationStatusID
     * @var int
     */
    public $NotificationStatusID;
    /**
     * The NotificationStatusName
     * @var string
     */
    public $NotificationStatusName;
    /**
     * The NotificationStatusDate
     * @var string
     */
    public $NotificationStatusDate;
    /**
     * The SendedID
     * @var int
     */
    public $SendedID;
    /**
     * The SourceOperation
     * @var string
     */
    public $SourceOperation;
    /**
     * Constructor method for SmsHistoryRecord
     * @uses SmsHistoryRecord::setId()
     * @uses SmsHistoryRecord::setNumber()
     * @uses SmsHistoryRecord::setNotificationTypeID()
     * @uses SmsHistoryRecord::setNotificationTypeName()
     * @uses SmsHistoryRecord::setNotificationStatusID()
     * @uses SmsHistoryRecord::setNotificationStatusName()
     * @uses SmsHistoryRecord::setNotificationStatusDate()
     * @uses SmsHistoryRecord::setSendedID()
     * @uses SmsHistoryRecord::setSourceOperation()
     * @param int $id
     * @param string $number
     * @param int $notificationTypeID
     * @param string $notificationTypeName
     * @param int $notificationStatusID
     * @param string $notificationStatusName
     * @param string $notificationStatusDate
     * @param int $sendedID
     * @param string $sourceOperation
     */
    public function __construct($id = null, $number = null, $notificationTypeID = null, $notificationTypeName = null, $notificationStatusID = null, $notificationStatusName = null, $notificationStatusDate = null, $sendedID = null, $sourceOperation = null)
    {
        $this
            ->setId($id)
            ->setNumber($number)
            ->setNotificationTypeID($notificationTypeID)
            ->setNotificationTypeName($notificationTypeName)
            ->setNotificationStatusID($notificationStatusID)
            ->setNotificationStatusName($notificationStatusName)
            ->setNotificationStatusDate($notificationStatusDate)
            ->setSendedID($sendedID)
            ->setSourceOperation($sourceOperation);
    }
    /**
     * Get Id value
     * @return int|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\SmsHistoryRecord
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param string $number
     * @return \StructType\SmsHistoryRecord
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get NotificationTypeID value
     * @return int|null
     */
    public function getNotificationTypeID()
    {
        return $this->NotificationTypeID;
    }
    /**
     * Set NotificationTypeID value
     * @param int $notificationTypeID
     * @return \StructType\SmsHistoryRecord
     */
    public function setNotificationTypeID($notificationTypeID = null)
    {
        // validation for constraint: int
        if (!is_null($notificationTypeID) && !is_numeric($notificationTypeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($notificationTypeID)), __LINE__);
        }
        $this->NotificationTypeID = $notificationTypeID;
        return $this;
    }
    /**
     * Get NotificationTypeName value
     * @return string|null
     */
    public function getNotificationTypeName()
    {
        return $this->NotificationTypeName;
    }
    /**
     * Set NotificationTypeName value
     * @param string $notificationTypeName
     * @return \StructType\SmsHistoryRecord
     */
    public function setNotificationTypeName($notificationTypeName = null)
    {
        // validation for constraint: string
        if (!is_null($notificationTypeName) && !is_string($notificationTypeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($notificationTypeName)), __LINE__);
        }
        $this->NotificationTypeName = $notificationTypeName;
        return $this;
    }
    /**
     * Get NotificationStatusID value
     * @return int|null
     */
    public function getNotificationStatusID()
    {
        return $this->NotificationStatusID;
    }
    /**
     * Set NotificationStatusID value
     * @param int $notificationStatusID
     * @return \StructType\SmsHistoryRecord
     */
    public function setNotificationStatusID($notificationStatusID = null)
    {
        // validation for constraint: int
        if (!is_null($notificationStatusID) && !is_numeric($notificationStatusID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($notificationStatusID)), __LINE__);
        }
        $this->NotificationStatusID = $notificationStatusID;
        return $this;
    }
    /**
     * Get NotificationStatusName value
     * @return string|null
     */
    public function getNotificationStatusName()
    {
        return $this->NotificationStatusName;
    }
    /**
     * Set NotificationStatusName value
     * @param string $notificationStatusName
     * @return \StructType\SmsHistoryRecord
     */
    public function setNotificationStatusName($notificationStatusName = null)
    {
        // validation for constraint: string
        if (!is_null($notificationStatusName) && !is_string($notificationStatusName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($notificationStatusName)), __LINE__);
        }
        $this->NotificationStatusName = $notificationStatusName;
        return $this;
    }
    /**
     * Get NotificationStatusDate value
     * @return string|null
     */
    public function getNotificationStatusDate()
    {
        return $this->NotificationStatusDate;
    }
    /**
     * Set NotificationStatusDate value
     * @param string $notificationStatusDate
     * @return \StructType\SmsHistoryRecord
     */
    public function setNotificationStatusDate($notificationStatusDate = null)
    {
        // validation for constraint: string
        if (!is_null($notificationStatusDate) && !is_string($notificationStatusDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($notificationStatusDate)), __LINE__);
        }
        $this->NotificationStatusDate = $notificationStatusDate;
        return $this;
    }
    /**
     * Get SendedID value
     * @return int|null
     */
    public function getSendedID()
    {
        return $this->SendedID;
    }
    /**
     * Set SendedID value
     * @param int $sendedID
     * @return \StructType\SmsHistoryRecord
     */
    public function setSendedID($sendedID = null)
    {
        // validation for constraint: int
        if (!is_null($sendedID) && !is_numeric($sendedID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sendedID)), __LINE__);
        }
        $this->SendedID = $sendedID;
        return $this;
    }
    /**
     * Get SourceOperation value
     * @return string|null
     */
    public function getSourceOperation()
    {
        return $this->SourceOperation;
    }
    /**
     * Set SourceOperation value
     * @param string $sourceOperation
     * @return \StructType\SmsHistoryRecord
     */
    public function setSourceOperation($sourceOperation = null)
    {
        // validation for constraint: string
        if (!is_null($sourceOperation) && !is_string($sourceOperation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sourceOperation)), __LINE__);
        }
        $this->SourceOperation = $sourceOperation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SmsHistoryRecord
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
