<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserParameters StructType
 * @subpackage Structs
 */
class UserParameters extends AbstractStructBase
{
    /**
     * The SendCtg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Rtm02Parameter
     */
    public $SendCtg;
    /**
     * The Sndr
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Sndr;
    /**
     * The Rcpn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Rcpn;
    /**
     * Constructor method for UserParameters
     * @uses UserParameters::setSendCtg()
     * @uses UserParameters::setSndr()
     * @uses UserParameters::setRcpn()
     * @param \StructType\Rtm02Parameter $sendCtg
     * @param string $sndr
     * @param string $rcpn
     */
    public function __construct(\StructType\Rtm02Parameter $sendCtg = null, $sndr = null, $rcpn = null)
    {
        $this
            ->setSendCtg($sendCtg)
            ->setSndr($sndr)
            ->setRcpn($rcpn);
    }
    /**
     * Get SendCtg value
     * @return \StructType\Rtm02Parameter|null
     */
    public function getSendCtg()
    {
        return $this->SendCtg;
    }
    /**
     * Set SendCtg value
     * @param \StructType\Rtm02Parameter $sendCtg
     * @return \StructType\UserParameters
     */
    public function setSendCtg(\StructType\Rtm02Parameter $sendCtg = null)
    {
        $this->SendCtg = $sendCtg;
        return $this;
    }
    /**
     * Get Sndr value
     * @return string|null
     */
    public function getSndr()
    {
        return $this->Sndr;
    }
    /**
     * Set Sndr value
     * @param string $sndr
     * @return \StructType\UserParameters
     */
    public function setSndr($sndr = null)
    {
        // validation for constraint: string
        if (!is_null($sndr) && !is_string($sndr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sndr)), __LINE__);
        }
        $this->Sndr = $sndr;
        return $this;
    }
    /**
     * Get Rcpn value
     * @return string|null
     */
    public function getRcpn()
    {
        return $this->Rcpn;
    }
    /**
     * Set Rcpn value
     * @param string $rcpn
     * @return \StructType\UserParameters
     */
    public function setRcpn($rcpn = null)
    {
        // validation for constraint: string
        if (!is_null($rcpn) && !is_string($rcpn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rcpn)), __LINE__);
        }
        $this->Rcpn = $rcpn;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UserParameters
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
